import processing.core.*;

public class Bot{
	public int size = 30;
	public int radius = size/2;
	public float xPos;
	public float yPos;
	public float velNoiseRate = 0.05f;//the static rate of change for velocity;
	public float rotNoiseRate = 0.01f;//the static rate of change for rotation;
	private float velNoisePos = 0.0f;//the position in the Perlin noise field for velocity
	private float rotNoisePos = 0.0f;//the position in the Perlin noise field for rotation
	private float currentVel = 0.0f;//current velocity of the bot in pixels;
	private float currentRot = 0.0f;//current rotation of the bot in degrees;
	public int rFood = 0, lFood = 0;
	EmergenceBots p;
	
	public Bot(EmergenceBots parent){
		this.p = parent;
		this.velNoisePos += p.random(1000);
		this.rotNoisePos += p.random(1000);
		this.xPos = p.random(p.width);
		this.yPos = p.random(p.height);
	}
	
	public void update(){
		/*
		 * Check for nearby brightness - DISCONTINUED DEVELOPMENT DUE TO TIME CONSTRAINTS
		 */
		/*for(int r=10;r<=50;r+=4){
			for(int th=0;th<=90;th+=5){
				if(r*p.sin(th)+xPos <= p.width && r*p.cos(th)+yPos <= p.height
					&& p.round( (r*p.cos(th)) * p.width + (r*p.sin(th))) < p.width*p.height
					&& p.round(r*p.cos(th))+yPos >= 0
					&& p.round(r*p.sin(th))+xPos >= 0
					&& p.round(((r*p.cos(th)+yPos)*p.width+(r*p.sin(th))+xPos)) >= 0){
						//if(p.brightness(p.pixels[p.round(((r*p.cos(th)+yPos)*p.width+(r*p.sin(th))+xPos))]) == 255.0){
							//p.pixels[(int)((r*p.cos(th)+this.yPos)*p.width+(r*p.sin(th))+this.xPos)] = p.color(0,200,0);
							p.set(p.round(r*p.sin(th)+this.xPos), p.round(r*p.cos(th)+this.yPos), p.color(0,175,0));
						//}
						//else{
							//p.set(p.round(r*p.sin(th)+this.xPos), p.round(r*p.cos(th)+this.yPos), p.color(175,0,0));
						//}
				}
			}
		}*/
		
		/*
		 * Refresh the next changes in velocity and rotation
		 */
		velNoisePos += velNoiseRate;
		rotNoisePos += rotNoiseRate;
		currentVel = ((1+(p.noise(velNoisePos)))/3)*2; //return the velocity between 0.5 and 1
		/*
		 * Return the noise value in a form of degrees.
		 * Perlin noise is mostly only generated in the middle levels 
		 * (no peaks or troughs), so we generate up to 1440 to take 
		 * the middle values from there.
		 */
		currentRot = 1440*(p.noise(rotNoisePos));	
		while(currentRot > 360){
			currentRot -= 360;
		}
		
		
		/*
		 * Update the position 
		 */
		this.yPos += currentVel*p.sin(p.radians(currentRot));
		this.xPos += currentVel*p.cos(p.radians(currentRot));		
		

		/*
		 * If hitting a wall, reflect
		 */
		if(this.xPos + radius >= p.width){
			this.xPos -= 3;
			this.rotNoisePos = p.random(1000);
		}
		else if(this.xPos - radius <= 0){
			this.xPos += 3;
			this.rotNoisePos = p.random(1000);
		}
		if(this.yPos + radius >= p.height){
			this.yPos -= 3;
			this.rotNoisePos = p.random(1000);
		}
		else if(this.yPos - radius <= 0){
			this.yPos += 3;
			this.rotNoisePos = p.random(1000);
		}
	
			
		
		/*
		 * Render the bot
		 */		
		p.fill(0);
		p.noStroke();
		p.ellipse(xPos, yPos, size, size);
		p.stroke(255,0,0);
		p.strokeWeight(2);
		p.line(this.xPos, this.yPos, this.xPos + radius*p.cos(p.radians(currentRot)), this.yPos + radius*p.sin(p.radians(currentRot)));
	}
}
